/* uchaine.c
 * Programmes de tests de l'implantation des chaines de caracteres
 * Auteur : VOURIOT Thierry
 * Date : 27 octobre 2001
 */

#include "chaine.h"

void aff_menu(void);

Chaine chmain;

int main() {

    Car c;
    Bool vid;
    Nat i,l;
    ecrch("\nEntrez une chaine de caratere : ");
    chmain = lirech();

    for (aff_menu();(c=getchar())!='q';aff_menu()) {

        getchar(); /* vide le tampon du caractre de retour  la ligne */
        switch(c) {
                  case 'a': { ecrch("\nEntrer une nouvelle chaine principale : ");chmain = lirech();break; }

                  case 'b': { ecrch("\nCaratere a ajouter en tete : ");chmain = at(chmain,getchar());getchar();break; }

                  case 'c': { ecrch("\nCaratere a ajouter en queue : ");chmain = aq(chmain,getchar());getchar();break; }

                  case 'd': { ecrch("\nInformations sur la chaine principale :");
                              vid = vide(chmain);
                              ecrch("\nChaine vide : ");
                              ecrch(vid ? "vrai" : "faux");
                              ecrch("\nCaratere en tete : ");putchar(t(chmain));
                              ecrch("\nCaratere en queue : ");putchar(q(chmain));
                              ecrch("\nCorps : ");ecrch(co(chmain));
                              ecrch("\nCorps inverse : ");ecrch(ci(chmain));
                              ecrch("\nLongueur : ");printf("%d \n",lgr(chmain));
                              break; }

                  case 'e': { ecrch("\nIndex de debut de la sous-chaine : "),i = atoi(lirech());
                              ecrch("Longueur de la sous-chaine : "),l = atoi(lirech());
                              ecrch("Sous-Chaine : "), ecrch(sch(chmain,i,l));
                              break; }

                  case 'f': { ecrch("\nChaine a concatener : ");chmain = conc(chmain,lirech());break; }

                  case 'g': { ecrch("\nCopie de la chaine principale : ");ecrch(copiech(chmain));break; }

                  case 'h': { destch(chmain);break; }
        }
    }
    return 0;
}

void aff_menu() {

     ecrch("\n\n TESTS DES CHAINES DE CARACTERES");
     ecrch("\nChaine principale pour effectuer les operations : ");
     ecrch(chmain);
     ecrch("\n\na. Changer la chaine principale");
     ecrch("\nb. Ajout d'un caratere en tete");
     ecrch("\nc. Ajout d'un caratere en queue");
     ecrch("\nd. Informations sur la chaine");
     ecrch("\ne. Extraction d'une sous-chaine");
     ecrch("\nf. Concatenation d'une chaine");
     ecrch("\ng. Copier de la chaine principale");
     ecrch("\nh. Destruction de la chaine principale");
     ecrch("\nq. Quitter");
     ecrch("\n\nChoix :");
}

